//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private UxxarPivotPoints_1_2[] cacheUxxarPivotPoints_1_2 = null;

        private static UxxarPivotPoints_1_2 checkUxxarPivotPoints_1_2 = new UxxarPivotPoints_1_2();

        /// <summary>
        /// Uxxar Pivot Points
        /// </summary>
        /// <returns></returns>
        public UxxarPivotPoints_1_2 UxxarPivotPoints_1_2()
        {
            return UxxarPivotPoints_1_2(Input);
        }

        /// <summary>
        /// Uxxar Pivot Points
        /// </summary>
        /// <returns></returns>
        public UxxarPivotPoints_1_2 UxxarPivotPoints_1_2(Data.IDataSeries input)
        {
            if (cacheUxxarPivotPoints_1_2 != null)
                for (int idx = 0; idx < cacheUxxarPivotPoints_1_2.Length; idx++)
                    if (cacheUxxarPivotPoints_1_2[idx].EqualsInput(input))
                        return cacheUxxarPivotPoints_1_2[idx];

            lock (checkUxxarPivotPoints_1_2)
            {
                if (cacheUxxarPivotPoints_1_2 != null)
                    for (int idx = 0; idx < cacheUxxarPivotPoints_1_2.Length; idx++)
                        if (cacheUxxarPivotPoints_1_2[idx].EqualsInput(input))
                            return cacheUxxarPivotPoints_1_2[idx];

                UxxarPivotPoints_1_2 indicator = new UxxarPivotPoints_1_2();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                UxxarPivotPoints_1_2[] tmp = new UxxarPivotPoints_1_2[cacheUxxarPivotPoints_1_2 == null ? 1 : cacheUxxarPivotPoints_1_2.Length + 1];
                if (cacheUxxarPivotPoints_1_2 != null)
                    cacheUxxarPivotPoints_1_2.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheUxxarPivotPoints_1_2 = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Uxxar Pivot Points
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.UxxarPivotPoints_1_2 UxxarPivotPoints_1_2()
        {
            return _indicator.UxxarPivotPoints_1_2(Input);
        }

        /// <summary>
        /// Uxxar Pivot Points
        /// </summary>
        /// <returns></returns>
        public Indicator.UxxarPivotPoints_1_2 UxxarPivotPoints_1_2(Data.IDataSeries input)
        {
            return _indicator.UxxarPivotPoints_1_2(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Uxxar Pivot Points
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.UxxarPivotPoints_1_2 UxxarPivotPoints_1_2()
        {
            return _indicator.UxxarPivotPoints_1_2(Input);
        }

        /// <summary>
        /// Uxxar Pivot Points
        /// </summary>
        /// <returns></returns>
        public Indicator.UxxarPivotPoints_1_2 UxxarPivotPoints_1_2(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.UxxarPivotPoints_1_2(input);
        }
    }
}
#endregion
